Extension { #name : 'RwRowanProjectIssuesTest' }

{ #category : '*rowan-services-testsv1' }
RwRowanProjectIssuesTest >> testIssue150_branches [

	"https://github.com/dalehenrich/Rowan/issues/150"

	"The issue #150 tests are mainly aimed at verifying that the given commands do not fail - ensuring that git version supports the
		commands and arguments used by Jadeite. "

	| rowanProject projectName service testBranch testClass  queryService |

	rowanProject := Rowan image _projectForNonTestProject: 'Rowan'.
	projectName := 'RowanSample3'.
	self 
		_cloneGitRepositoryFor: projectName 
		projectUrlString:  'file:' , rowanProject repositoryRootPath , '/samples/', projectName, '.ston'.

	queryService := 	RowanQueryService new
		projectBranches: projectName;
		yourself.

	service := RowanProjectService new
		name: projectName;
		yourself.

	testBranch := 'issue_150_v2'.
	service 
		checkout: testBranch;
		branch;
		repositorySha;
		log;
		pullFromGit;
		yourself.
	Rowan projectTools load loadProjectNamed: projectName.
	testClass := Rowan globalNamed: 'RowanSample3'.
	testClass 
		rwCompileMethod: 'foo
 "', DateAndTime now printString, '"
^1 '
		category: 'accessing'.
	service
		commitWithMessage: 'a commit';
		pushToGit;
		yourself
]
